<?php

namespace Teknisa\DF\Modules\Saida\NFSe\Utilities;

use Teknisa\Libs\Util\Utilities;

//use Teknisa\Libs\Util\Utilities as UtilGeral;

class Util {
    
    const DEV_LINK  = 'http://midiatest.teknisa.com/files/';
    const PROD_LINK = 'http://midia.teknisa.com/files/';

    public static function decrypt($text, $salt = 'teknisa'){
            return Utilities::zeedhiDecrypt($text, $salt);
        
    }

    public static function formatarNumero($numero, $casasDecimais = 2) {
        return number_format($numero, $casasDecimais, '.', '');
    }

    public static function getInformacoesEmailEmpresa ($connection, $nrorg, $cdempresa){
         $sql = "SELECT DSASSUNTONFE,DSMENSEMAILNFE ,DSEMAILCCNFE
                FROM EMPRESA
                WHERE NRORG = :NRORG
                    AND CDEMPRESA = :CDEMPRESA";

        $params = array(
            "CDEMPRESA"  => $cdempresa,
            "NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return $dataset;
    }
    
    public static function getFraseSecreta($connection, $cdempresa, $cdinscmuni, $nrorg){
        $sql = "SELECT CDFRASESECRETA 
                FROM PARAMNFSEINSCMUNI
                WHERE CDEMPRESA  = :P_CDEMPRESA
                   AND CDINSCMUNI = :P_CDINSCMUNI
                   AND NRORG      = :P_NRORG
                   AND IDATIVO    = 'S'";
        $params = array(
                "P_CDEMPRESA" => $cdempresa, 
                "P_CDINSCMUNI" => $cdinscmuni, 
                "P_NRORG" => $nrorg
            );
       
        $std = $connection->prepare($sql);
        $std->execute($params);
        $palavraSecreta = $std->fetchAll();
        return self::decrypt($palavraSecreta[0]['CDFRASESECRETA']);
    }
    public static function getEmailEmpresa ($connection, $nrorg, $cdfilial){
         $sql = "SELECT DSLOGINSMTP, DSEMAILEMXMLNFE, DSEMAILFILI
                FROM ENDEFILI
                WHERE NRORG = :NRORG
                    AND CDFILIAL = :CDFILIAL
                    AND IDTPENDEFILI = 'P'";

        $params = array(
            "CDFILIAL"  => $cdfilial,
            "NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return $dataset;
    }

    public static function getDadosGeracao($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $sql = "SELECT NVL(M.CDMUNICSIAFI, I.CDMUNICIPIO) AS CDMUNICIPIO,
                       M.CDMUNICIBGE,
                       I.SGESTADO,
                       I.CDPAIS,
                       I.NRORG
              FROM INSCRMUNICIP I
              JOIN MUNICIPIO M
                    ON  I.CDPAIS      = M.CDPAIS
                    AND I.SGESTADO    = M.SGESTADO
                    AND I.CDMUNICIPIO = M.CDMUNICIPIO
                    AND I.NRORG       = M.NRORG
              WHERE I.CDEMPRESA  = :CDEMPRESA
                AND I.CDINSCMUNI = :CDINSCMUNI
                AND I.NRORG      = :NRORG";
    
        if(is_array($cdempresa))    $cdempresa = $cdempresa[0];
        if(is_array($cdinscmuni))   $cdinscmuni = $cdinscmuni[0];
    
        $params = array(
            "CDEMPRESA"  => $cdempresa,
            "CDINSCMUNI" => $cdinscmuni,
            "NRORG"      => $nrorg
        );
        
        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return (count($dataset) > 0) ? $dataset[0] : null;
    }

    public static function getCorpoNF($connection, $nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT NF.CDFILIAL,
                  NF.NRLANCTONF,
                  TO_CHAR(NF.DTENTRSAID, 'YYYY-MM-DD') AS DTENTRSAID,
                  IE.CDPAIS                            AS CDPAISEMP,
                  IE.SGESTADO                          AS SGESTADOEMP,
                  IE.CDMUNICIPIO                       AS CDMUNICIPIOEMP,
                  M.CDMUNICIBGE                        AS CDMUNICIBGEEMP,
                  M.NMMUNICIPIO                        AS NMMUNICIPIOEMP,
                  IE.DSENDEIEST                        AS DSENDEEMP,
                  IE.DSCOMPENDIES                      AS DSCOMPENDEMP,
                  IE.NMBAIRIEST                        AS NMBAIREMP,
                  IE.NRCEPIEST                         AS NRCEPEMP,
                  IM.CDINSCMUNI                        AS CDINSCMUNIEMP,
                  IE.CDINSCESTA,
                  E.IDNATUOPEREMPR,
                  E.IDREGESPTRIBEMP,
                  E.IDINCENTFISCAL,                  
                  E.NMRAZSOCEMPR AS NMRAZSOCEMIT,
                  S.CDSERIERPS,
                  VRPRODUTOS,
                  VRNOTAFISC,
                  TO_CHAR(ROUND(NF.VRPRODUTOS, 2), '9999999999990.00') AS VALORPRODUTOS,
                  TO_CHAR(ROUND(NF.VRNOTAFISC, 2), '9999999999990.00') AS VALORNOTAFISCAL,
                  IE.NRINSJURIEST,
                  IM.NRCERTDIGNFSE,
                  C.IDTPIJURCLIE,
                  C.NRINSJURCLIE,
                  PC.CDPAISBACEN AS CDPAISBACENCLIE,
                  MEC.SGESTADO   AS SGESTADOCLIE,
                  C.NRINSMUNICLIE,
                  C.NRINSESTCLIE,
                  C.NMRAZSOCCLIE,
                  EC.DSENDECLIE,
                  EC.DSCOMPENDCLI,
                  EC.NMBAIRCLIE,
                  MEC.CDMUNICIPIO AS CDMUNICIPIOCLIE,
                  MEC.NMMUNICIPIO AS NMMUNICIPIOCLIE,
                  MEC.CDMUNICIBGE AS CDMUNICIBGECLIE,
                  EC.NRCEPCLIE,
                  NVL(SUBSTR(NVL(DSEMAILCLIENFE, NVL(DSEMAILCLIE, DSEMAILCLIE2)), 0, (INSTR(NVL(DSEMAILCLIENFE, NVL(DSEMAILCLIE, DSEMAILCLIE2)), ';')-1)), NVL(DSEMAILCLIENFE, NVL(DSEMAILCLIE, DSEMAILCLIE2))) AS DSEMAILCLIENFE,
                  IE.NRTELEIEST                                                                                                                                                                                 AS NRTELEEMIT,
                  EC.NRTELECLIE,
                  M.CDMUNICSIAFI   AS CDMUNICSIAFIEMP,
                  MEC.CDMUNICSIAFI AS CDMUNICSIAFICLIE,
                  NF.CDEMPRESA,
                  NVL(E.IDOPTSIMPLES, 'N') AS IDOPTSIMPLES,
                  E.CDCNAE,
                  NVL(MP.CDMUNICSIAFI, NVL(MP.CDMUNICIPIO, NVL(MEC.CDMUNICSIAFI, MEC.CDMUNICIPIO))) AS CDMUNISERVPRES,
                  NVL(MP.CDMUNICIBGE, MEC.CDMUNICIBGE)                                              AS CDMUNICIBGESERVPRES,
                  NVL(MP.NMMUNICIPIO, MEC.NMMUNICIPIO)                                              AS NMMUNISERVPRES,  
                  NVL(MP.CDPAIS,      IE.CDPAIS)                                                    AS CDPAIS
                FROM NOTAFISCAL NF,
                  EMPRESA E,
                  INSCRESTAD IE,
                  INSCRMUNICIP IM,
                  MUNICIPIO M,
                  CLIENTE C,
                  ENDECLIE EC,
                  MUNICIPIO MEC,
                  SERIENF S,
                  PAIS PC,
                  DADOSERVPRES D,
                  MUNICIPIO MP
                WHERE NF.CDFILIAL      = :P_CDFILIAL
                AND NF.NRLANCTONF      = :P_NRLANCTONF
                AND NF.NRORG           = :P_NRORG
                AND NF.CDEMPRESA       = E.CDEMPRESA
                AND NF.NRORG           = E.NRORG
                AND NF.CDEMPRESA       = IE.CDEMPRESA
                AND NF.CDINSCESTA      = IE.CDINSCESTA
                AND NF.NRORG           = IE.NRORG
                AND NF.NRLANCTONF      = D.NRLANCTONF(+)
                AND NF.CDFILIAL        = D.CDFILIAL(+)
                AND NF.NRORG           = D.NRORG(+)
                AND D.CDMUNICIPRESSERV = MP.CDMUNICIPIO(+)
                AND D.SGESTADOPRESSERV = MP.SGESTADO(+)
                AND D.CDPAISPRESSERV   = MP.CDPAIS(+)
                AND IE.CDPAIS          = M.CDPAIS(+)
                AND IE.SGESTADO        = M.SGESTADO(+)
                AND IE.CDMUNICIPIO     = M.CDMUNICIPIO(+)
                AND NF.CDEMPRESA       = IM.CDEMPRESA
                AND NF.CDINSCMUNI      = IM.CDINSCMUNI
                AND NF.NRORG           = IM.NRORG
                AND NF.CDCLIENTE       = C.CDCLIENTE
                AND NF.NRORG           = C.NRORG
                AND C.CDCLIENTE        = EC.CDCLIENTE(+)
                AND C.NRORG            = EC.NRORG(+)
                AND EC.CDPAIS          = MEC.CDPAIS(+)
                AND EC.SGESTADO        = MEC.SGESTADO(+)
                AND EC.CDMUNICIPIO     = MEC.CDMUNICIPIO(+)
                AND EC.CDPAIS          = PC.CDPAIS(+)
                AND EC.IDTPENDECLIE    = NVL(C.IDENDEMISCLI,'P')
                AND ((NF.IDORIGDESTNF IS NULL)
                OR (NF.IDORIGDESTNF    = 'C'))
                AND NF.CDEMPRESA       = S.CDEMPRESA(+)
                AND NF.CDINSCESTA      = S.CDINSCESTA(+)
                AND NF.CDINSCMUNI      = S.CDINSCMUNI(+)
                AND NF.CDSERIE         = S.CDSERIE(+)
                AND NF.NRORG           = S.NRORG(+)";

        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return $dataset[0];
    }

    public static function getImpostos($connection, $nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT NVL(IP.CDIMPOSTONFE, IT.CDIMPOSTO) AS CDIMPOSTONFE,
                       IT.CDIMPOSTO,
                       SUM(IT.VRIMPOSTONF) AS VRIMPOSTOIT,
                       TO_CHAR(ROUND(SUM(IT.VRIMPOSTONF), 2), '9999999999990.00') AS VALORIMPOSTO,
                       TO_CHAR(ROUND(SUM(IT.VRBASECALCNF), 2), '9999999999990.00') AS BASECALCULO,
                       IP.IDTRATIMPO
                  FROM IMPOSTONF IT, IMPOSTO IP
                 WHERE IT.CDFILIAL    = :P_CDFILIAL
                   AND IT.NRLANCTONF  = :P_NRLANCTONF
                   AND IT.NRORG       = :P_NRORG
                   AND IP.CDIMPOSTO   = IT.CDIMPOSTO
                   AND IP.NRORG       = IT.NRORG
                   AND IT.IDIMPOSTONF = '1'
                   AND IT.CDFISCALNF  = '1'
                 GROUP BY CDIMPOSTONFE, IT.CDIMPOSTO, IP.IDTRATIMPO";

        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public static function getDadosNfCt($connection, $cdFilial, $nrLanctonf) {
        $sql = "SELECT F.CDPAIS,
              F.SGESTADO,
              F.CDMUNICIPIO,
              M.CDMUNICIBGE,
              F.DSREFERENCIANOTA
            FROM FCT_DADOSNF F
            JOIN MUNICIPIO M
            ON (F.CDPAIS       = M.CDPAIS)
            AND (F.SGESTADO    = M.SGESTADO)
            AND (F.CDMUNICIPIO = M.CDMUNICIPIO)
            WHERE CDFILIAL     = :P_CDFILIAL
            AND NRLANCTONF     = :P_NRLANCTONF";
            
        $params = array(
            "P_NRLANCTONF" => $nrLanctonf,
            "P_CDFILIAL"   => $cdFilial
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function getOutrasRetencoes($connection, $nrlanctonf, $cdfilial, $nrorg) {

        $sql = "SELECT SUM(IT.VRIMPOSTOIT) AS VRIMPOSTOIT, TO_CHAR(ROUND(SUM(IT.VRIMPOSTOIT), 2), '9999999999990.00') AS VALORIMPOSTO
                  FROM ITEMPRODUTO I, ITEMPROIMPOS IT, IMPOSTO IP
                 WHERE I.CDFILIAL      = :P_CDFILIAL
                   AND I.NRLANCTONF    = :P_NRLANCTONF
                   AND I.NRORG         = :P_NRORG
                   AND I.CDFILIAL      = IT.CDFILIAL
                   AND I.NRLANCTONF    = IT.NRLANCTONF
                   AND I.NRSEQITPROD   = IT.NRSEQITPROD
                   AND I.NRORG         = IT.NRORG
                   AND IP.CDIMPOSTO    = IT.CDIMPOSTO
                   AND IP.NRORG        = IT.NRORG
                   AND IT.NRITPROIMPOS = '1'
                   AND (('1' = IT.CDFISCALIT) OR (IP.IDIMPORECUP = 'N'))
                   AND IP.IDTRATIMPO = 'R'
                   AND NOT EXISTS (SELECT 1
                                     FROM IMPOSTONFE IMP
                                    WHERE IMP.CDIMPOSTONFE = IP.CDIMPOSTONFE
                                    AND IMP.NRORG          = IP.NRORG)";

        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return $dataset[0];
    }

    public static function getImpostoItemMaiorAliquota($connection, $nrlanctonf, $cdfilial, $cdimpostonfe, $nrorg) {

        $nrseqitprod = self::getItemMaiorAliquota($connection, $cdfilial, $nrlanctonf, $nrorg);
        if (!is_null($nrseqitprod)) {
            $sql = "SELECT II.CDFILIAL,
                           II.NRLANCTONF,
                           II.NRSEQITPROD,
                           II.VRALIQITEM,
                           DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999')), LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999'))) AS VRALIQUOTA
                      FROM ITEMPROIMPOS II, IMPOSTO IP
                     WHERE II.CDFILIAL     = :P_CDFILIAL
                       AND II.NRLANCTONF   = :P_NRLANCTONF
                       AND II.NRORG        = :P_NRORG
                       AND II.NRSEQITPROD  = :P_NRSEQITPROD
                       AND II.CDIMPOSTO    = IP.CDIMPOSTO
                       AND II.NRORG        = IP.NRORG
                       AND II.CDFISCALIT   = '1'
                       AND IP.CDIMPOSTONFE = :P_CDIMPOSTONFE";

            $params = array(
                "P_CDFILIAL"     => $cdfilial,
                "P_NRLANCTONF"   => $nrlanctonf,
                "P_NRORG"        => $nrorg,
                "P_NRSEQITPROD"  => $nrseqitprod,
                "P_CDIMPOSTONFE" => $cdimpostonfe
            );

            $std = $connection->prepare($sql);
            $std->execute($params);
            $dataset = $std->fetchAll();
            return (count($dataset) > 0) ? $dataset[0] : null;
        }
        else {
            return null;
        }
    }

    private static function getItemMaiorAliquota($connection, $cdfilial, $nrlanctonf, $nrorg) {
        $sql = "SELECT IMPOSTO.NRSEQITPROD FROM (
                          SELECT II.NRSEQITPROD, II.VRALIQITEM
                            FROM ITEMPROIMPOS II, IMPOSTO I
                           WHERE II.CDFILIAL    = :P_CDFILIAL
                             AND II.NRLANCTONF  = :P_NRLANCTONF
                             AND II.NRORG       = :P_NRORG
                             AND II.CDIMPOSTO   = I.CDIMPOSTO
                             AND II.NRORG       = I.NRORG
                             AND I.CDIMPOSTONFE IN ('31', '35', '36')
                           ORDER BY II.VRALIQITEM DESC) IMPOSTO
                 WHERE ROWNUM = 1";

        $params = array(
            "P_NRLANCTONF"   => $nrlanctonf,
            "P_CDFILIAL"     => $cdfilial,
            "P_NRORG"        => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return (count($dataset) > 0) ? $dataset[0]["NRSEQITPROD"] : null;
    }

    public static function getImpostosItem($connection, $nrlanctonf, $cdfilial, $nrorg, $cdimpostonfe = null, $nrseqitprod = null) {
        $sql = "SELECT II.CDFILIAL,
                       II.NRLANCTONF,
                       II.NRSEQITPROD,
                       IP.CDIMPOSTONFE,
                       II.VRALIQITEM,
                       II.CDFISCALIT,
                       II.VRIMPOSTOIT,
                       DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999')), LTRIM(TO_CHAR(ROUND(II.VRALIQITEM / 100, 4), '999999.9999'))) AS VRALIQUOTA
                  FROM ITEMPROIMPOS II, IMPOSTO IP
                 WHERE II.CDFILIAL      = :P_CDFILIAL
                   AND II.NRLANCTONF    = :P_NRLANCTONF
                   AND II.NRORG         = :P_NRORG
                   AND II.CDIMPOSTO     = IP.CDIMPOSTO
                   AND II.NRORG         = IP.NRORG
                   AND (IP.CDIMPOSTONFE = :P_CDIMPOSTONFE OR :P_CDIMPOSTONFE IS NULL)
                   AND (II.NRSEQITPROD  = :P_NRSEQITPROD  OR :P_NRSEQITPROD IS NULL)";

        $params = array(
            "P_CDFILIAL"     => $cdfilial,
            "P_NRLANCTONF"   => $nrlanctonf,
            "P_NRORG"        => $nrorg,
            "P_CDIMPOSTONFE" => $cdimpostonfe,
            "P_NRSEQITPROD"  => $nrseqitprod
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function getItemEncargo($connection, $nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT EN.IDENCARGO,
                       EN.NMENCARGO,
                       ROUND(IT.VRITEMENCA, 2) AS VRITEMENCA,
                         EN.NMENCARGO || ' R$: ' || DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRITEMENCA, 10), '999999999999.00')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRITEMENCA, 10), '999999999999.00')), LTRIM(TO_CHAR(ROUND(IT.VRITEMENCA, 10), '999999999999.00'))) AS DESCRICAO
                  FROM ENCARGO EN, ITEMENCARGO IT
                 WHERE EN.CDENCARGO  = IT.CDENCARGO
                   AND EN.NRORG      = IT.NRORG
                   AND EN.IDENCARGO  IN ('D', 'A')
                   AND IT.VRITEMENCA > 0
                   AND IT.CDFILIAL   = :P_CDFILIAL
                   AND IT.NRLANCTONF = :P_NRLANCTONF
                   AND IT.NRORG      = :P_NRORG
                 ORDER BY EN.IDENCARGO, EN.CDENCARGO";

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function getItemProduto($connection, $nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT IP.CDFILIAL,
                       IP.NRLANCTONF,
                       IP.NRSEQITPROD,
                       IP.CDPRODUTO,
                       PR.CDARVPROD,
                       PR.NMPRODUTO,
                       IP.DSPRODEMIS,
                       IP.QTITEMPROD,
                       IP.VRUNITITEM,
                       IP.VRTOTAITEM,
                       IP.VRDESCITEM,
                       (IP.VRTOTAITEM - IP.VRDESCITEM) AS VRLIQUIDO
                  FROM ITEMPRODUTO IP, PRODUTO PR
                 WHERE IP.CDPRODUTO  = PR.CDPRODUTO
                   AND IP.NRORG      = PR.NRORG
                   AND IP.CDFILIAL   = :P_CDFILIAL
                   AND IP.NRLANCTONF = :P_NRLANCTONF
                   AND IP.NRORG      = :P_NRORG
                 ORDER BY IP.NRSEQITPROD";

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function inserirLoteRps($connection, $cdempresa, $cdinscesta, $cdinscmuni, $nrinsjuriest, $nrorg, $cdoperador, $newCode) {
        $sql = "INSERT INTO LOTERPS
                   (CDEMPLOTERPS,      NRSEQLOTERPS,     CDINSCESTA,
                    CDINSCMUNI,        NRINSJURIEST,     DTINCLUSAO,
                    CDOPERINCLUSAO,    NRORGINCLUSAO,    NRORG)
                VALUES
                   (:P_CDEMPLOTERPS,   :P_NRSEQLOTERPS,  :P_CDINSCESTA,
                   :P_CDINSCMUNI,      :P_NRINSJURIEST,  SYSDATE,
                   :P_CDOPERINCLUSAO,  :P_NRORG,         :P_NRORG)";

        $chave = "LOTERPS".$cdempresa.$nrinsjuriest;
        //$nrseqloterps = NovoCodigo::geraCodigo($connection, $chave, $nrorg, false, 15);
        $nrseqloterps = $newCode->getCodeByTableName($chave, $nrorg, 1, 15);
        $params = array(
            "P_CDEMPLOTERPS"   => $cdempresa,
            "P_NRSEQLOTERPS"   => $nrseqloterps,
            "P_CDINSCESTA"     => $cdinscesta,
            "P_CDINSCMUNI"     => $cdinscmuni,
            "P_NRINSJURIEST"   => $nrinsjuriest,
            "P_CDOPERINCLUSAO" => $cdoperador,
            "P_NRORG"          => $nrorg
        );

        $std = $connection->prepare($sql);
        
        $std->execute($params);
        return $nrseqloterps;
    }

    public static function inserirNumeroRps($connection, $nrseqloterps, $idtransmisrps, $cdempresa, $cdserierps, $nrrps, $cdinscesta, $cdinscmuni, $nrinsjuriest, $nrnotafiscse, $cdverifnfse, $nrorg, $cdoperador, $newCode) {
        $sql = "INSERT INTO NUMERORPS
                   (CDSERIERPS,       NRRPS,              CDEMPLOTERPS,       CDINSCESTA,
                    CDINSCMUNI,       NRSEQLOTERPS,       DTEMISSAORPS,       IDTRANSMISRPS,
                    IDSTATUSRPS,      IDSTATUSNFSE,       DTEMISSAONFSE,      NRINSJURIEST,
                    DTCOMPETNFSE,     NRNOTAFISCSE,       CDVERIFNFSE,        IDEMISSAORPS,
                    DTINCLUSAO,       CDOPERINCLUSAO,     NRORGINCLUSAO,      NRORG)
                VALUES
                   (:P_CDSERIERPS,    :P_NRRPS,           :P_CDEMPLOTERPS,    :P_CDINSCESTA,
                    :P_CDINSCMUNI,    :P_NRSEQLOTERPS,    SYSDATE,            :P_IDTRANSMISRPS,
                    :P_IDSTATUSRPS,   :P_IDSTATUSNFSE,    NULL,               :P_NRINSJURIEST,
                    NULL,             :P_NRNOTAFISCSE,    :P_CDVERIFNFSE,     :P_IDEMISSAORPS,
                    SYSDATE,          :P_CDOPERINCLUSAO,  :P_NRORG,           :P_NRORG)";

        if (empty($nrrps)) {
            $chave = "NUMERORPS".$cdempresa.$nrinsjuriest.$cdserierps;
            $nrrps = $newCode->getCodeByTableName($chave, $nrorg, 1, 15);
        }
        else {
            self::atualizarNovoCodigo($connection, $cdempresa, $nrinsjuriest, $cdserierps, $nrrps, $nrorg);
        }

        $params = array(
            "P_CDSERIERPS"     => $cdserierps,
            "P_NRRPS"          => $nrrps,
            "P_CDEMPLOTERPS"   => $cdempresa,
            "P_CDINSCESTA"     => $cdinscesta,
            "P_CDINSCMUNI"     => $cdinscmuni,
            "P_NRSEQLOTERPS"   => $nrseqloterps,
            "P_IDTRANSMISRPS"  => $idtransmisrps,
            "P_IDSTATUSRPS"    => 1,
            "P_IDSTATUSNFSE"   => 1,
            "P_NRINSJURIEST"   => $nrinsjuriest,
            "P_NRNOTAFISCSE"   => $nrnotafiscse,
            "P_CDVERIFNFSE"    => $cdverifnfse,
            "P_IDEMISSAORPS"   => 1,
            "P_CDOPERINCLUSAO" => $cdoperador,
            "P_NRORG"          => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $nrrps;
    }

    public static function atualizarNovoCodigo($connection, $cdempresa, $nrinsjuriest, $cdserierps, $nrrps, $nrorg) {
        $existeNumeroRps = "SELECT :P_QTDE FROM NOVOCODIGO WHERE CDCONTADOR = :P_CDCONTADOR AND NRORG = :P_NRORG";
        
        $chave = "NUMERORPS".$cdempresa.$nrinsjuriest.$cdserierps;

        $params = array(
            "P_QTDE"       => $nrrps,
            "P_CDCONTADOR" => $chave,
            "P_NRORG"      => $nrorg
        );
        $existe = $connection->prepare($existeNumeroRps);
        $existe->execute($params);
        $existe = $existe->fetchAll();
        $atualiza = "UPDATE NOVOCODIGO
                   SET NRSEQUENCIAL = LPAD(RTRIM(TO_CHAR(:P_QTDE)),20,'0')
                 WHERE CDCONTADOR = :P_CDCONTADOR
                   AND NRORG      = :P_NRORG";
                   
        $insere = "INSERT INTO NOVOCODIGO
                  (
                    CDCONTADOR,
                    NRSEQUENCIAL,
                    NRORG
                  )
                  VALUES
                  (
                    :P_CDCONTADOR,
                    LPAD(RTRIM(TO_CHAR(:P_QTDE)),20,'0'),
                    :P_NRORG
                  )";
        
        if(isset($existe[0])) {
            $std = $connection->prepare($atualiza);
            $std->execute($params);
        }
        else {
            $std = $connection->prepare($insere);
            $std->execute($params);
        }

    }

    public static function getCodTribMuni($connection, $cdempresa, $cdinscmuni, $cdarvprod, $nrorg) {
        $sql = "SELECT C.CDPRODUTO, C.CDTRIBPRODPADR, C.CDCLASSERVPADR, C.DSCLASSERVPADR
                  FROM CODTRIBPRODPADR C,
                       (SELECT MAX(C.CDPRODUTO) AS CDPRODUTO
                          FROM CODTRIBPRODPADR C, PRODUTO P
                         WHERE C.CDPRODUTO  = P.CDPRODUTO
                           AND C.NRORG      = P.NRORG
                           AND C.CDEMPRESA  = :P_CDEMPRESA
                           AND C.CDINSCMUNI = :P_CDINSCMUNI
                           AND C.NRORG      = :P_NRORG
                           AND INSTR(:P_CDARVPROD, NVL(RTRIM(P.CDARVPROD), :P_CDARVPROD)) = 1) P
                 WHERE C.CDEMPRESA  = :P_CDEMPRESA
                   AND C.CDINSCMUNI = :P_CDINSCMUNI
                   AND C.NRORG      = :P_NRORG
                   AND C.CDPRODUTO  = P.CDPRODUTO";

        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg,
            "P_CDARVPROD"  => $cdarvprod
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        return (count($dataset) > 0) ? $dataset[0] : null;
    }

    public static function getDadosAdicionais($connection, $nrlanctonf, $cdfilial, $nrorg) {
        $sql = "SELECT CDFILIAL, NRLANCTONF, NRDADOADIC, CDMENSAGEM,
                       DSDADOADIC
                  FROM DADOSADIC
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                   AND NRORG      = :P_NRORG";

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function atualizarLote($connection, $cdempresa, $cdinscesta, $cdinscmuni, $nrseqloterps, $idstatusloterps, $nrprotocolorps, $nrorg, $cdoperador) {
        $sql = "UPDATE LOTERPS
                   SET IDSTATUSLOTERPS = :IDSTATUSLOTERPS,
                       NRPROTOCOLORPS  = :NRPROTOCOLORPS, ";

            if ($idstatusloterps == 2) {
                $sql .= " DTENVIOLOTERPS  = :DTENVIOLOTERPS, ";
            }

              $sql .= " DTULTATU    = SYSDATE,
                       CDOPERULTATU = :CDOPERULTATU,
                       NRORGULTATU  = :NRORGULTATU
                 WHERE CDEMPLOTERPS = :CDEMPLOTERPS
                   AND CDINSCESTA   = :CDINSCESTA
                   AND CDINSCMUNI   = :CDINSCMUNI
                   AND NRSEQLOTERPS = :NRSEQLOTERPS
                   AND NRORG        = :NRORG";

        $params = array();
        $params["IDSTATUSLOTERPS"] = $idstatusloterps;
        $params["NRPROTOCOLORPS"] = $nrprotocolorps;

        if ($idstatusloterps == 2) {
            $data = date_create();
            $data = $data->format("d/m/Y H:i:s");
            $params["DTENVIOLOTERPS"] = $data;
        }

        $params["CDOPERULTATU"] = $cdoperador;
        $params["NRORGULTATU"] = $nrorg;
        $params["CDEMPLOTERPS"] = $cdempresa;
        $params["CDINSCESTA"] = $cdinscesta;
        $params["CDINSCMUNI"] = $cdinscmuni;
        $params["NRSEQLOTERPS"] = $nrseqloterps;
        $params["NRORG"] = $nrorg;

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    public static function atualizarNotaTransmissao($connection, $cdserierps, $nrrps, $cdempresa, $cdinscesta, $cdinscmuni, $nrseqloterps, $cdfilial, $nrlanctonf, $nrorg, $cdoperador) {
        $sql = "UPDATE NOTAFISCAL
                   SET CDSERIERPS   = :P_CDSERIERPS,
                       NRRPS        = :P_NRRPS,
                       CDEMPRESA    = :P_CDEMPRESA,
                       CDINSCESTA   = :P_CDINSCESTA,
                       CDINSCMUNI   = :P_CDINSCMUNI,
                       NRSEQLOTERPS = :P_NRSEQLOTERPS,
                       DTEMISSAO    = (CASE WHEN TRUNC(SYSDATE) > TRUNC(DTENTRSAID) THEN DTENTRSAID ELSE TRUNC(SYSDATE) END),
                       DTULTATU     = SYSDATE,
                       CDOPERULTATU = :P_CDOPERULTATU,
                       NRORGULTATU  = :P_NRORGULTATU
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                   AND NRORG      = :P_NRORG";

        $params = array(
            "P_CDSERIERPS"   => $cdserierps,
            "P_NRRPS"        => $nrrps,
            "P_CDEMPRESA"    => $cdempresa,
            "P_CDINSCESTA"   => $cdinscesta,
            "P_CDINSCMUNI"   => $cdinscmuni,
            "P_NRSEQLOTERPS" => $nrseqloterps,
            "P_CDOPERULTATU" => $cdoperador,
            "P_NRORGULTATU"  => $nrorg,
            "P_CDFILIAL"     => $cdfilial,
            "P_NRLANCTONF"   => $nrlanctonf,
            "P_NRORG"        => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    public static function atualizarNotaConsulta($connection, $cdserierps, $nrrps, $cdemploterps, $cdinscesta, $cdinscmuni, $nrseqloterps, $nrnotafisc, $nrorg, $cdoperador, $chaveAcesso = null) {
        $sql = "UPDATE NOTAFISCAL
                   SET NRNOTAFISC   = :P_NRNOTAFISC,
                       IDBLOQUEADO  = 'S',
                       DTULTATU     = SYSDATE,
                       CDOPERULTATU = :P_CDOPERULTATU,
                       NRORGULTATU  = :P_NRORGULTATU,
                       NRACESSONFE  = :P_NRACESSONFE
                 WHERE CDSERIERPS 	= :P_CDSERIERPS
                   AND NRRPS 		= :P_NRRPS
                   AND CDEMPRESA 	= :P_CDEMPLOTERPS
                   AND CDINSCESTA 	= :P_CDINSCESTA
                   AND CDINSCMUNI 	= :P_CDINSCMUNI
                   AND NRSEQLOTERPS = :P_NRSEQLOTERPS
                   AND NRORG        = :P_NRORG";

        $params = array(
            "P_NRNOTAFISC"   => $nrnotafisc,
            "P_CDOPERULTATU" => $cdoperador,
            "P_NRORGULTATU"  => $nrorg,
            "P_NRACESSONFE"  => $chaveAcesso,
            "P_CDSERIERPS"   => $cdserierps,
            "P_NRRPS"        => $nrrps,
            "P_CDEMPLOTERPS" => $cdemploterps,
            "P_CDINSCESTA"   => $cdinscesta,
            "P_CDINSCMUNI"   => $cdinscmuni,
            "P_NRSEQLOTERPS" => $nrseqloterps,
            "P_NRORG"        => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    //Retira os acentos de uma string.
    public static function retiraAcento($texto) {
        $acentos = array('á'=>'a', 'à'=>'a', 'ã'=>'a', 'â'=>'a', 'ä'=>'a', 'é'=>'e', 'ê'=>'e', 'è'=>'e', 'ë'=>'e', 'í'=>'i', 'ì'=>'i', 'ï'=>'i',
            'î'=>'i', 'ó'=>'o', 'ô'=>'o', 'ò'=>'o', 'õ'=>'o', 'ö'=>'o', 'ú'=>'u', 'ü'=>'u', 'ù'=>'u', 'û'=>'u', 'ç'=>'c', 'Á'=>'A',
            'À'=>'A', 'Ã'=>'A', 'Â'=>'A', 'Ä'=>'A', 'É'=>'E', 'Ê'=>'E', 'È'=>'E', 'Ë'=>'E', 'Í'=>'I', 'Ì'=>'I', 'Ï'=>'I', 'Î'=>'I',
            'Ó'=>'O', 'Ô'=>'O', 'Õ'=>'O', 'Ò'=>'O', 'Ö'=>'O', 'Ú'=>'U', 'Ù'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ç'=>'C');
        return strtr($texto, $acentos);
    }

    /**
     * @param \DOMNode
     * @param string
     * @return \DOMNode
     */
    public static function getChildNodeByName(\DOMNode $node, $name) {
        foreach ($node->childNodes as $childNode) {
            if ($childNode->nodeName == $name) {
                return $childNode;
            }
        }
        return null;
    }

    public static function atualizarNumeroRps($connection, $cdserierps, $nrrps, $cdemploterps, $cdinscesta, $cdinscmuni, $nrseqloterps, $nrnotafiscse, $cdverifnfse, $idtransmisrps, $dtemissaonfse, $dtcompetnfse, $nrorg, $cdoperador) {
        $sql = "UPDATE NUMERORPS
                   SET NRNOTAFISCSE  = :P_NRNOTAFISCSE,
                       CDVERIFNFSE   = :P_CDVERIFNFSE,
                       DTEMISSAONFSE = :P_DTEMISSAONFSE,
                       DTCOMPETNFSE  = :P_DTCOMPETNFSE,
                       IDTRANSMISRPS = :P_IDTRANSMISRPS,
                       DTULTATU      = SYSDATE,
                       IDEMISSAORPS  = :P_IDEMISSAORPS,
                       CDOPERULTATU  = :P_CDOPERULTATU,
                       NRORGULTATU   = :P_NRORGULTATU
                 WHERE CDSERIERPS   = :P_CDSERIERPS
                   AND NRRPS        = :P_NRRPS
                   AND CDEMPLOTERPS = :P_CDEMPLOTERPS
                   AND CDINSCESTA   = :P_CDINSCESTA
                   AND CDINSCMUNI   = :P_CDINSCMUNI
                   AND NRSEQLOTERPS = :P_NRSEQLOTERPS
                   AND NRORG        = :P_NRORG";

        $params = array(
            "P_NRNOTAFISCSE"  => $nrnotafiscse,
            "P_CDVERIFNFSE"   => $cdverifnfse,
            "P_DTEMISSAONFSE" => $dtemissaonfse,
            "P_DTCOMPETNFSE"  => $dtcompetnfse,
            "P_IDTRANSMISRPS" => $idtransmisrps,
            "P_IDEMISSAORPS"  => ($idtransmisrps == 4) ? 3 : 1,
            "P_CDOPERULTATU"  => $cdoperador,
            "P_NRORGULTATU"   => $nrorg,
            "P_CDSERIERPS"    => $cdserierps,
            "P_NRRPS"         => $nrrps,
            "P_CDEMPLOTERPS"  => $cdemploterps,
            "P_CDINSCESTA"    => $cdinscesta,
            "P_CDINSCMUNI"    => $cdinscmuni,
            "P_NRSEQLOTERPS"  => $nrseqloterps,
            "P_NRORG"         => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    public static function atualizarSituacaoNumeroRpsPeloLote($connection, $cdserierps, $cdemploterps, $cdinscesta, $cdinscmuni, $nrseqloterps, $idtransmisrps, $nrorg, $cdoperador) {

        $params = array(
            "P_IDTRANSMISRPS" => $idtransmisrps,
            "P_CDOPERULTATU"  => $cdoperador,
            "P_NRORGULTATU"   => $nrorg,
            "P_CDEMPLOTERPS"  => $cdemploterps,
            "P_CDINSCESTA"    => $cdinscesta,
            "P_CDINSCMUNI"    => $cdinscmuni,
            "P_NRSEQLOTERPS"  => $nrseqloterps,
            "P_NRORG"         => $nrorg
        );

        $sql = "UPDATE NUMERORPS
                   SET IDTRANSMISRPS = :P_IDTRANSMISRPS,
                       DTULTATU      = SYSDATE,
                       NRNOTAFISCSE  = NULL,
                       CDVERIFNFSE   = NULL,
                       DTEMISSAONFSE = NULL,
                       DTCOMPETNFSE  = NULL,
                       CDOPERULTATU  = :P_CDOPERULTATU,
                       NRORGULTATU   = :P_NRORGULTATU
                 WHERE CDEMPLOTERPS = :P_CDEMPLOTERPS
                   AND CDINSCESTA   = :P_CDINSCESTA
                   AND CDINSCMUNI   = :P_CDINSCMUNI
                   AND NRSEQLOTERPS = :P_NRSEQLOTERPS
                   AND NRORG        = :P_NRORG ";

        if (!is_null($cdserierps)) {
            $sql .= " AND CDSERIERPS = :P_CDSERIERPS";
            $params["P_CDSERIERPS"] = $cdserierps;
        }

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    public static function getProximoCodigoNumeroRps($connection, $cdemploterps, $nrinsjuriest, $cdserierps, $nrorg) {
        $sql = "SELECT (TO_NUMBER(NRSEQUENCIAL) + 1) AS COD
                  FROM NOVOCODIGO
                 WHERE CDCONTADOR = :P_CDCONTADOR
                   AND NRORG      = :P_NRORG";

        $cdcontador = "NUMERORPS".$cdemploterps.$nrinsjuriest.$cdserierps;
        $params = array(
            "P_CDCONTADOR" => $cdcontador,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $retorno = $std->fetchAll();
        return (is_array($retorno) && count($retorno) > 0) ? $retorno[0]["COD"] : 1;
    }

    public static function inserirNotaCancelada($connection, $idbloqueado, $idstatus, $dsmotivocancnfe, $idstatusnfe, $cdfilial, $nrlanctonf, $nrorg, $cdoperador, $newCode) {
        $sql = "INSERT INTO NOTAFISCAL
         (CDFILIAL,
          NRLANCTONF,
          CDSERIERPS,
          NRRPS,
          NRSEQLOTERPS,
          DTEMISSAO,
          NRNOTAFISC,
          IDBLOQUEADO,
          CDEMPRESA,
          CDINSCESTA,
          CDINSCMUNI,
          IDTPIJURNF,
          NRINSJURNF,
          CDFORNECED,
          CDCLIENTE,
          DTENTRSAID,
          VRPRODUTOS,
          VRNOTAFISC,
          CDOPERAPRO,
          NRPLACAVEIC,
          SGUFVEIC,
          IDPGTOFRETE,
          DSQTDEVOLU,
          DSESPECVOLU,
          DSMARCAVOLU,
          DSNUMEVOLU,
          VRPBRUTOVOLU,
          VRPLIQUVOLU,
          IDENTRSAIDOP,
          CDTIPOOPER,
          CDSERIE,
          IDTPIJURTRAN,
          NRINSJURTRAN,
          CDFILIEMIT,
          CDFILIRECE,
          IDERROS,
          IDAVISOS,
          IDDOCFISCAL,
          IDDOCFINANC,
          DTINIAPUFISC,
          DTAPROVACAO,
          DTCONTABIL,
          VRTTMOEDESTR,
          CDFISOPENTF,
          DSCDFISOPENF,
          IDSTATUS,
          IDORIGDESTNF,
          DTSAIDEMIS,
          DTCANCELANF,
          CDOPECANCNF,
          DTEXPRNF,
          NREXPRNF,
          DSMOTIVOCANCNFE,
          NRACESSONFE,
          NRPROTOCOLONFE,
          IDTIPOEMISNFE,
          IDSTATUSNFE,
          NRNOTAFISCALELE,
          DSOBSSTATUSNFE,
          CDEMPLOTENFE,
          NRLOTENFE,
          CDSERIEENTR,
          IDTPAMBNFE,
          CDMODDOCFISC,
          IDEMAILNFE)
      (SELECT :P_NOVO_CDFILIAL AS CDFILIAL,
              :P_NOVO_NRLANCTONF AS NRLANCTONF,
              CDSERIERPS,
              NRRPS,
              NRSEQLOTERPS,
              DTEMISSAO,
              NRNOTAFISC,
              :P_IDBLOQUEADO,
              CDEMPRESA,
              CDINSCESTA,
              CDINSCMUNI,
              IDTPIJURNF,
              NRINSJURNF,
              CDFORNECED,
              CDCLIENTE,
              DTENTRSAID,
              VRPRODUTOS,
              VRNOTAFISC,
              CDOPERAPRO,
              NRPLACAVEIC,
              SGUFVEIC,
              IDPGTOFRETE,
              DSQTDEVOLU,
              DSESPECVOLU,
              DSMARCAVOLU,
              DSNUMEVOLU,
              VRPBRUTOVOLU,
              VRPLIQUVOLU,
              IDENTRSAIDOP,
              CDTIPOOPER,
              CDSERIE,
              IDTPIJURTRAN,
              NRINSJURTRAN,
              CDFILIEMIT,
              CDFILIRECE,
              IDERROS,
              IDAVISOS,
              IDDOCFISCAL,
              IDDOCFINANC,
              DTINIAPUFISC,
              DTAPROVACAO,
              DTCONTABIL,
              VRTTMOEDESTR,
              CDFISOPENTF,
              DSCDFISOPENF,
              :P_IDSTATUS,
              IDORIGDESTNF,
              DTSAIDEMIS,
              SYSDATE,
              CDOPECANCNF,
              DTEXPRNF,
              NREXPRNF,
              :P_DSMOTIVOCANCNFE,
              NRACESSONFE,
              NRPROTOCOLONFE,
              IDTIPOEMISNFE,
              :P_IDSTATUSNFE,
              NRNOTAFISCALELE,
              DSOBSSTATUSNFE,
              CDEMPLOTENFE,
              NRLOTENFE,
              CDSERIEENTR,
              IDTPAMBNFE,
              CDMODDOCFISC,
              IDEMAILNFE
         FROM NOTAFISCAL
        WHERE CDFILIAL   = :P_CDFILIAL
          AND NRLANCTONF = :P_NRLANCTONF
          AND NRORG      = :P_NRORG)";

        $chave = "LANCNF/FILIAL".$cdfilial;
        //$novo_nrlanctonf = NovoCodigo::geraCodigo($connection, $chave, $nrorg, false, 10);
        $novo_nrlanctonf = $newCode->getCodeByTableName($chave, $nrorg, 1, 10);

        $params = array(
            "P_NOVO_CDFILIAL"   => $cdfilial,
            "P_NOVO_NRLANCTONF" => $novo_nrlanctonf,
            "P_IDBLOQUEADO"     => $idbloqueado,
            "P_IDSTATUS"        => $idstatus,
            "P_DSMOTIVOCANCNFE" => $dsmotivocancnfe,
            "P_IDSTATUSNFE"     => $idstatusnfe,
            "P_CDFILIAL"        => $cdfilial,
            "P_NRLANCTONF"      => $nrlanctonf,
            "P_NRORG"           => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);

        self::trocarXml($connection, $cdfilial, $nrlanctonf, $novo_nrlanctonf, $nrorg, $cdoperador);
    }

    public static function atualizarNotaCancelada($connection, $idbloqueado, $cdfilial, $nrlanctonf, $nrorg) {
        $sql = "UPDATE NOTAFISCAL
                   SET CDSERIERPS   = NULL,
                       NRRPS        = NULL,
                       NRSEQLOTERPS = NULL,
                       DTEMISSAO    = NULL,
                       NRNOTAFISC   = NULL,
                       IDBLOQUEADO  = :P_IDBLOQUEADO,
                       IDEMAILNFE   = 'P'
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                   AND NRORG      = :P_NRORG";

        $params = array(
            "P_IDBLOQUEADO" => $idbloqueado,
            "P_CDFILIAL"    => $cdfilial,
            "P_NRLANCTONF"  => $nrlanctonf,
            "P_NRORG"       => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
    }

    public static function inserirArquivoXml($connection, $cdserierps, $nrrps, $cdemploterps, $cdinscesta, $cdinscmuni, $nrseqloterps, $idtipoarqxml, $xml, $nrorg, $cdoperador) {

        $sql = "SELECT CDFILIAL, NRLANCTONF
                  FROM NOTAFISCAL
                 WHERE CDSERIERPS   = :CDSERIERPS
                   AND NRRPS 	    = :NRRPS
                   AND CDEMPRESA    = :CDEMPLOTERPS
                   AND CDINSCESTA   = :CDINSCESTA
                   AND CDINSCMUNI   = :CDINSCMUNI
                   AND NRSEQLOTERPS = :NRSEQLOTERPS
                   AND NRORG        = :NRORG";

        $params = array(
            "CDSERIERPS"   => $cdserierps,
            "NRRPS"        => $nrrps,
            "CDEMPLOTERPS" => $cdemploterps,
            "CDINSCESTA"   => $cdinscesta,
            "CDINSCMUNI"   => $cdinscmuni,
            "NRSEQLOTERPS" => $nrseqloterps,
            "NRORG"        => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        if (count($dataset) > 0) {
            $cdfilial = $dataset[0]["CDFILIAL"];
            $nrlanctonf = $dataset[0]["NRLANCTONF"];

            $sql = "INSERT INTO ARQXMLNFE (
                        CDFILIAL,
                        NRLANCTONF,
                        IDTIPOARQXML,
                        DSARQXMLNFSE,
                        NRORG,
                        DTINCLUSAO,
                        NRORGINCLUSAO,
                        CDOPERINCLUSAO,
                        IDATIVO)
                    VALUES (
                        :CDFILIAL,
                        :NRLANCTONF,
                        :IDTIPOARQXML,
                        :DSARQXMLNFSE,
                        :NRORG,
                        SYSDATE,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :IDATIVO)";

            $params = array(
                "CDFILIAL"       => $cdfilial,
                "NRLANCTONF"     => $nrlanctonf,
                "IDTIPOARQXML"   => $idtipoarqxml,
                "DSARQXMLNFSE"   => $xml,
                "NRORG"          => $nrorg,
                "CDOPERINCLUSAO" => $cdoperador,
                "IDATIVO"        => "S"
            );

            $std = $connection->prepare($sql);
            $std->execute($params);
        }
    }

    public static function getAmbiente($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $sql = "SELECT IDAMBIENTE
                  FROM PARAMNFSEINSCMUNI
                 WHERE CDEMPRESA  = :CDEMPRESA
                   AND CDINSCMUNI = :CDINSCMUNI
                   AND NRORG      = :NRORG
                   AND IDATIVO    = 'S'";

        $params = array(
            "CDEMPRESA" => $cdempresa,
            "CDINSCMUNI" => $cdinscmuni,
            "NRORG" => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        // 1 = producao, 2 = homologacao
        return (count($dataset) > 0) ? (int)$dataset[0]["IDAMBIENTE"] : null;
    }

    public static function utilizaAprovacaoAutomatica($connection, $cdempresa, $nrorg) {
        $sql = "SELECT IDAPROVNFTRANS
                  FROM PARAMEMPRESA
                 WHERE CDEMPRESA  = :CDEMPRESA
                   AND NRORG      = :NRORG";

        $params = array(
            "CDEMPRESA" => $cdempresa,
            "NRORG" => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        return (count($dataset) > 0) ? $dataset[0]["IDAPROVNFTRANS"] : null;
    }
    
    public static function utilizaEnvioEmail($connection, $cdempresa, $nrorg) {
        $sql = "SELECT IDEMAILNFTRANS
                  FROM PARAMEMPRESA
                 WHERE CDEMPRESA  = :CDEMPRESA
                   AND NRORG      = :NRORG";

        $params = array(
            "CDEMPRESA" => $cdempresa,
            "NRORG" => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        return (count($dataset) > 0) ? $dataset[0]["IDEMAILNFTRANS"] : null;
    }

    public static function trocarXml($connection, $cdfilial, $nrlanctonf, $novo_nrlanctonf, $nrorg, $cdoperador) {
        $sql = "SELECT DSARQXMLNFSE
                  FROM ARQXMLNFE
                 WHERE CDFILIAL     = :CDFILIAL
                   AND NRLANCTONF   = :NRLANCTONF
                   AND NRORG        = :NRORG";

        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRORG" => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        if (count($dataset) > 0) {
            $xml = $dataset[0]["DSARQXMLNFSE"];

            $sql = "UPDATE ARQXMLNFE
                    SET NRLANCTONF  = :NRLANCTONF_NOVO
                 WHERE CDFILIAL     = :CDFILIAL
                   AND NRLANCTONF   = :NRLANCTONF
                   AND NRORG        = :NRORG";

            $params = array(
                "NRLANCTONF_NOVO" => $novo_nrlanctonf,
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );

            $std = $connection->prepare($sql);
            $std->execute($params);
        }
    }

    public static function getSenhaCertificadoDigital($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg
        );

        $dataset = self::getSenhasCriptografadas($connection, $params);
        if (is_array($dataset) && count($dataset) > 0) {
            $senhaCriptografada = $dataset[0]["CDSENHACERTDIG"];
            return self::decrypt($senhaCriptografada);
            //return UtilGeral::decrypt($senhaCriptografada);
        }
        else return null;
    }

    public static function getSenhaAcessoWS($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg
        );

        $dataset = self::getSenhasCriptografadas($connection, $params);
        if (is_array($dataset) && count($dataset) > 0) {
            $senhaCriptografada = $dataset[0]["CDSENHAACESSOWS"];
            return Utilities::zeedhiDecrypt($senhaCriptografada, 'teknisa');
            //return UtilGeral::decrypt($senhaCriptografada);
        }
        else return null;
    }

    private static function getSenhasCriptografadas($connection, $params) {
        $sql = "SELECT CDSENHACERTDIG, CDSENHAACESSOWS
                  FROM PARAMNFSEINSCMUNI
                 WHERE CDEMPRESA  = :P_CDEMPRESA
                   AND CDINSCMUNI = :P_CDINSCMUNI
                   AND NRORG      = :P_NRORG
                   AND IDATIVO    = 'S'";

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public static function getEmailCliente($connection, $cdfilial, $nrlanctonf, $nrorg) {
        $sql = "SELECT NVL(EN.DSEMAILCLIENFE, NVL(EN.DSEMAILCLIE, EN.DSEMAILCLIE2)) AS DSEMAILCLIENFE
                  FROM ENDECLIE EN
                 INNER JOIN CLIENTE C
                    ON EN.CDCLIENTE = C.CDCLIENTE
                   AND EN.NRORG     = C.NRORG
                 INNER JOIN NOTAFISCAL NF
                    ON EN.CDCLIENTE = NF.CDCLIENTE
                    AND EN.NRORG    = NF.NRORG
                 WHERE NF.CDFILIAL   = :P_CDFILIAL
                   AND NF.NRLANCTONF = :P_NRLANCTONF
                   AND NF.NRORG      = :P_NRORG
                   AND EN.IDTPENDECLIE = NVL(C.IDENDEMISCLI,'P')";

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRORG"      => $nrorg
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        if (is_array($dataset) && count($dataset) > 0)
            return $dataset[0]["DSEMAILCLIENFE"];
        else
            return null;
    }
    
    private static function getInscrMunicip($connection, $cdinscmuni, $cdempresa, $nrorg) {
        $sql = 'SELECT CDINSCMUNI,
                CDEMPRESA,
                NRORG,
                DSDIRCERTIFICADO AS DSDIRCERT
        FROM PARAMNFSEINSCMUNI
        WHERE CDINSCMUNI = :P_CDINSCMUNI
        AND CDEMPRESA    = :P_CDEMPRESA
        AND NRORG        = :P_NRORG';
        
        $params = array(
            'P_CDINSCMUNI' => $cdinscmuni,
            'P_CDEMPRESA'  => $cdempresa,
            'P_NRORG'      => $nrorg
        );

        $query = $connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }

    public static function getDataSetCertificadoFileServer($connection, $cdinscmuni, $cdempresa, $nrorg, $fileserverlink, $mode = 'prod') {
        $inscrMunicip      = self::getInscrMunicip($connection, $cdinscmuni, $cdempresa, $nrorg);
         if($inscrMunicip[0]) {
            $inscrMunicip = $inscrMunicip[0];
            $filesString  = $inscrMunicip['DSDIRCERT'];
            
        }
        else throw new \Exception("Certificado não encontrado.");
        $filesArray = array();
        $array = array_filter(explode('<', $filesString));
        $count = 0;
        foreach ($array as $element) {
            $element = explode('>', $element);
            $file = array("fileName" => $element[0]);
            $file["path"] = ($mode === 'prod') ? $fileserverlink.$element[1] : self::DEV_LINK.$element[1];
            array_push($filesArray, $file);
            $count++;
        }
        return $filesArray;
    }


    public static function getSenhaParaFrase($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $sql = 'SELECT CDSENHAACESSOWS
                FROM PARAMNFSEINSCMUNI
                WHERE CDINSCMUNI = :P_CDINSCMUNI
                AND CDEMPRESA    = :P_CDEMPRESA
                AND NRORG        = :P_NRORG';

        $params = array(
            'P_CDINSCMUNI' => $cdinscmuni,
            'P_CDEMPRESA'  => $cdempresa,
            'P_NRORG'      => $nrorg
        );

        $query = $connection->prepare($sql);
        $query->execute($params);
        
        $senhaCriptografada = $query->fetchAll();
        return self::decrypt($senhaCriptografada[0]['CDSENHAACESSOWS']);
        
    }
    
    public static function clienteRecebeBoleto($connection, $cdcliente) {
        $sql = "SELECT IDUTILBOLNFSE FROM CLIENTE WHERE CDCLIENTE = :P_CDCLIENTE";

        $params = array(
            "P_CDCLIENTE"   => $cdcliente
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();
        if (is_array($dataset) && count($dataset) > 0)
            return $dataset[0]["IDUTILBOLNFSE"];
        else
            return 'N';
    }
    
    public static function getParamNFSeInscMuni($connection, $cdempresa, $cdinscmuni, $nrorg) {
        $sql = 'SELECT CDSENHAACESSOWS
                FROM PARAMNFSEINSCMUNI
                WHERE CDINSCMUNI = :P_CDINSCMUNI
                AND CDEMPRESA    = :P_CDEMPRESA
                AND NRORG        = :P_NRORG';
                
        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg
        );

        $query = $connection->prepare($sql);
        $query->execute($params);
        
        $dataset = $query->fetchAll();
        
        if (is_array($dataset) && count($dataset) > 0) {
            $senhaCriptografada = $dataset[0]["CDSENHAACESSOWS"];
            if($senhaCriptografada) {
                $senhaAcesso        = self::decrypt($senhaCriptografada);
            }
            else $senhaAcesso = '';
            
            return array("CDSENHAACESSOWS" => $senhaAcesso);
            //return UtilGeral::decrypt($senhaCriptografada);
        }
        else return null;
    }
    
    public static function getCodigoBacenPais($connection, $cdpais) {
        $sql = "SELECT CDPAISBACEN FROM PAIS WHERE CDPAIS = :P_CDPAIS";
            
        $params = array(
            "P_CDPAIS" => $cdpais
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public static function clienteEnviaBoletoAntesNota($connection, $cdfilial, $nrlanctonf  ) {
        $sql = "SELECT IDENVBOLANTNOTA, BR.IDSTATBREC
                FROM CLIENTE CC,
                  CONTARECEBER C,
                  BOLETRECEBER BR,
                  NOTAFISCAL N
                WHERE CC.CDCLIENTE = N.CDCLIENTE
                AND N.NRLANCTONF   = C.NRLANCTONF(+)
                AND N.CDFILIAL     = C.CDFILIAL(+)
                AND C.NRLANBOLREC  = BR.NRLANBOLREC(+)
                AND C.CDFILIBOLREC = BR.CDFILIAL(+)
                AND N.CDFILIAL     = :P_CDFILIAL
                AND NVL(C.NRPARCELAREC, '00') = '00'
                AND N.NRLANCTONF   = :P_NRLANCTONF";
            
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public static function getNotafiscalSubstituicaoNfse($connection, $cdfilial, $nrlanctonf) {
        $sql = "SELECT
                  E.NRORG,
                  E.CDFILIAL,
                  E.NRLANCTONF,
                  N.DTEMISSAO,
                  N.VRNOTAFISC,
                  S.CDSERIERPS,
                  R.NRRPS,
                  R.NRNOTAFISCSE,
                  E.CDFILIALSUBST,
                  E.NRLANCTONFSUBST,
                  CASE N.IDORIGDESTNF
                      WHEN 'C'   THEN
                          C.IDTPIJURCLIE
                      WHEN 'F'   THEN
                          F.IDTPIJURFORN
                      ELSE
                          L.IDTPIJURFILI
                  END AS IDTPIJURTOMA,
                  CASE N.IDORIGDESTNF
                      WHEN 'C'   THEN
                          C.NRINSJURCLIE
                      WHEN 'F'   THEN
                          F.NRINSJURFORN
                      ELSE
                          L.NRINSJURFILI
                  END AS NRINSJURTOMA,
                  CASE N.IDORIGDESTNF
                      WHEN 'C'   THEN
                          C.NMRAZSOCCLIE
                      WHEN 'F'   THEN
                          F.NMRAZSOCFORN
                      ELSE
                          L.NMRAZSOCFILI
                  END AS NMRAZSOCTOMA
              FROM
                  NOTAFISCAL         N
                  LEFT JOIN CLIENTE            C ON ( N.CDCLIENTE = C.CDCLIENTE )
                  LEFT JOIN FORNECEDOR         F ON ( N.CDFORNECED = F.CDFORNECED )
                  LEFT JOIN FILIAL             L ON ( N.CDFILIEMIT = L.CDFILIAL )
                  JOIN SERIENF            S ON ( N.CDEMPRESA = S.CDEMPRESA )
                                    AND ( N.CDINSCESTA = S.CDINSCESTA )
                                    AND ( N.CDINSCMUNI = S.CDINSCMUNI )
                                    AND ( N.CDSERIE = S.CDSERIE )
                  JOIN NUMERORPS          R ON ( N.CDSERIERPS = R.CDSERIERPS )
                                      AND ( N.NRRPS = R.NRRPS )
                                      AND ( N.CDEMPRESA = R.CDEMPLOTERPS )
                                      AND ( N.CDINSCESTA = R.CDINSCESTA )
                                      AND ( N.CDINSCMUNI = R.CDINSCMUNI )
                                      AND ( N.NRSEQLOTERPS = R.NRSEQLOTERPS )
                  JOIN RELNFSUBSTITUIDO   E ON ( N.CDFILIAL = E.CDFILIALSUBST )
                                             AND ( N.NRLANCTONF = E.NRLANCTONFSUBST )
              WHERE
                  E.CDFILIAL = :P_CDFILIAL
                  AND E.NRLANCTONF = :P_NRLANCTONF";
                  
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf
        );

        $std = $connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
}