<?php

namespace Teknisa\DF\Modules\Saida\Services;

use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;

class Dfs65001ParametrosNfseInscmuniService {
    protected $environment;
    protected $paramFactory;
    
    public function __construct(Environment $environment, $parametrosNfseInscmuniFactory) {
        $this->environment = $environment;
        $this->paramFactory = $parametrosNfseInscmuniFactory;
    }
    
    public function verificarInscricaoMunicipal($dados) {
        $nrorg = (isset($dados["NRORG"]) ? $dados["NRORG"] : $this->environment->getNrOrgTrab());
        $nrparamnfseinscmuni = $dados["NRPARAMNFSEINSCMUNI"];
        if ($dados["__is_new"] == true) {
            $nrorg = $this->environment->getNrOrg();
            $nrparamnfseinscmuni = -1;
        }
        
        $params = array(
            "P_CDEMPRESA"           => $dados["CDEMPRESA"],
            "P_CDINSCMUNI"          => $dados["CDINSCMUNI"],
            "P_NRORG"               => $nrorg,
            "P_NRPARAMNFSEINSCMUNI" => $nrparamnfseinscmuni
        );
        
        $dataset = $this->paramFactory->verificarInscricaoMunicipal($params);
        if (is_array($dataset) && count($dataset) > 0) {
            return ((int)$dataset[0]["EXISTE"] > 0);
        }
        else {
            return false;
        }
    }
    
    public function getLocalServidor($cdempresa, $cdinscmuni, $nrorg) {
        
        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg
        );
        
        $dataset = $this->paramFactory->getLocalServidor($params);
        if (is_array($dataset) && count($dataset) > 0) {
            return $dataset[0]["IDLOCALSERVIDOR"];
        }
        else {
            return null;
        }
    }
    
    public function remove($row){
        $this->paramFactory->remove($row);
    }
    
    public function getModeloNfse($cdempresa, $cdinscmuni, $nrorg) {
        $params = array(
            "P_CDEMPRESA"  => $cdempresa,
            "P_CDINSCMUNI" => $cdinscmuni,
            "P_NRORG"      => $nrorg
        );
        
        $dataset = $this->paramFactory->getModeloNfse($params);
        if (is_array($dataset) && count($dataset) > 0) {
            return $dataset[0]["DSCAMINHOMODELO"];
        }
        else {
            return false;
        }
    }
    
}